<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="单号" prop="orderId">
        <el-input
          v-model="queryParams.orderId"
          placeholder="请输入单号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="出库单号" prop="listId">
        <el-input
          v-model="queryParams.listId"
          placeholder="请输入出库单号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="物料号" prop="goodsId">
        <el-input
          v-model="queryParams.goodsId"
          placeholder="请输入物料号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="是否锁定" prop="isLock">
        <el-input
          v-model="queryParams.isLock"
          placeholder="请输入是否锁定"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['app:pmsOrderOut:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['app:pmsOrderOut:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['app:pmsOrderOut:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['app:pmsOrderOut:export']"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-remove"
          size="mini"
          @click="handleOut"
        >出库</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="pmsOrderOutList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="记录号" align="center" prop="recordId" /> -->
      <el-table-column label="单号" align="center" prop="orderId" width="270"/>
      <el-table-column label="出库单号" align="center" prop="listId" />
      <el-table-column label="出库单类型" align="center" prop="orderType" />
      <el-table-column label="客户名称" align="center" prop="customerId" />
      <el-table-column label="物料号" align="center" prop="goodsId" />
      <el-table-column label="订单出库数量" align="center" prop="goodsNum" />
      <el-table-column label="总出库数量" align="center" prop="pickNum" />
      <el-table-column label="确认出库数量" align="center" prop="trNum" />
      <el-table-column label="本次出库数量" align="center" prop="shelvesNum" width="200">
        <template slot-scope="scope">
          <el-input-number
            class="item"
            v-model="scope.row.shelvesNum"
            :min="0"
            :max="scope.row.goodsNum"
            :disabled="scope.row.sts == 1"
          ></el-input-number>
        </template>
      </el-table-column>
      <el-table-column label="库存数量" align="center" prop="stockNum" />
      <el-table-column label="物料描述" align="center" prop="goodsDesc" />
      <el-table-column label="订单状态" align="center" prop="orderStatus" />
      <el-table-column label="是否锁定" align="center" prop="isLock" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['app:pmsOrderOut:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['app:pmsOrderOut:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改出库单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="wms订单号" prop="orderId">
          <el-input v-model="form.orderId" placeholder="请输入wms订单号" />
        </el-form-item>
        <el-form-item label="出库单号" prop="listId">
          <el-input v-model="form.listId" placeholder="请输入出库单号" />
        </el-form-item>
        <el-form-item label="客户名称" prop="customerId">
          <el-input v-model="form.customerId" placeholder="请输入客户名称" />
        </el-form-item>
        <el-form-item label="物料号" prop="goodsId">
          <el-input v-model="form.goodsId" placeholder="请输入物料号" />
        </el-form-item>
        <el-form-item label="订单出库数量" prop="goodsNum">
          <el-input v-model="form.goodsNum" placeholder="请输入订单出库数量" />
        </el-form-item>
        <el-form-item label="总出库数量" prop="pickNum">
          <el-input v-model="form.pickNum" placeholder="请输入总出库数量" />
        </el-form-item>
        <el-form-item label="确认出库数量" prop="trNum">
          <el-input v-model="form.trNum" placeholder="请输入确认出库数量" />
        </el-form-item>
        <el-form-item label="本次出库数量" prop="shelvesNum">
          <el-input v-model="form.shelvesNum" placeholder="请输入本次出库数量" />
        </el-form-item>
        <el-form-item label="库存数量" prop="stockNum">
          <el-input v-model="form.stockNum" placeholder="请输入库存数量" />
        </el-form-item>
        <el-form-item label="物料描述" prop="goodsDesc">
          <el-input v-model="form.goodsDesc" placeholder="请输入物料描述" />
        </el-form-item>
        <el-form-item label="预留1" prop="spare1">
          <el-input v-model="form.spare1" placeholder="请输入预留1" />
        </el-form-item>
        <el-form-item label="预留2" prop="spare2">
          <el-input v-model="form.spare2" placeholder="请输入预留2" />
        </el-form-item>
        <el-form-item label="是否锁定" prop="isLock">
          <el-input v-model="form.isLock" placeholder="请输入是否锁定" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listPmsOrderOut, getPmsOrderOut, delPmsOrderOut, addPmsOrderOut, updatePmsOrderOut } from "@/api/system/pmsOrderOut";
import {createOutRequestByPmsOrders} from "@/api/system/task";
export default {
  name: "PmsOrderOut",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 出库单表格数据
      pmsOrderOutList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        orderId: null,
        listId: null,
        goodsId: null,
        orderStatus: null,
        isLock: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        recordId: [
          { required: true, message: "记录号不能为空", trigger: "blur" }
        ],
        orderId: [
          { required: true, message: "wms订单号不能为空", trigger: "blur" }
        ],
        listId: [
          { required: true, message: "出库单号不能为空", trigger: "blur" }
        ],
        goodsId: [
          { required: true, message: "物料号不能为空", trigger: "blur" }
        ],
        goodsNum: [
          { required: true, message: "订单出库数量不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询出库单列表 */
    getList() {
      this.loading = true;
      listPmsOrderOut(this.queryParams).then(response => {
        this.pmsOrderOutList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        recordId: null,
        orderId: null,
        listId: null,
        orderType: null,
        customerId: null,
        goodsId: null,
        goodsNum: null,
        pickNum: null,
        trNum: null,
        shelvesNum: null,
        stockNum: null,
        goodsDesc: null,
        spare1: null,
        spare2: null,
        orderStatus: null,
        isLock: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.recordId)
      selection.forEach((element) => {
        if (element.shelvesNum == undefined || element.shelvesNum == 0) {
          element.shelvesNum = element.goodsNum - element.pickNum;
        }
        if(element.orderStatus == 1){
          element.sts = 1;
        }
        if(element.goodsNum == element.pickNum){
          element.sts = 1;
          element.shelvesNum = 0;
        }
      });
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加出库单";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const recordId = row.recordId || this.ids
      getPmsOrderOut(recordId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改出库单";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.recordId != null) {
            updatePmsOrderOut(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPmsOrderOut(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const recordIds = row.recordId || this.ids;
      this.$modal.confirm('是否确认删除出库单编号为"' + recordIds + '"的数据项？').then(function() {
        return delPmsOrderOut(recordIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    handleOut(row){
      const recordIds = row.recordId || this.ids;
      if (recordIds == "" || recordIds == undefined || recordIds.length == 0) {
        this.$modal.msgError("请选择要出库的通知单列表！");
        return;
      }
      var reqArr = [];
      var error = false;

      for (var j = 0; j < recordIds.length; j++) {
        for (var i = 0; i < this.pmsOrderOutList.length; i++) {
          if (recordIds[j] == this.pmsOrderOutList[i].recordId) {
            if(this.pmsOrderOutList[i].shelvesNum ==0){
              this.$modal.msgError("物料号为" + this.pmsOrderOutList[i].goodsId + "已出库完成！");
              error = true;
              break;
            }
            reqArr.push(this.pmsOrderOutList[i]);
            break;
          }
        }
      }
      if (error) {
        return;
      }
    
      this.$modal
        .confirm("请确认本次出库数量是否正确，是否出库？")
        .then(function () {
          return createOutRequestByPmsOrders(reqArr);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("出库任务创建成功");
        })
        .catch(() => {
          this.$modal.msgSuccess("出库任务创建异常");
        });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('app/pmsOrderOut/export', {
        ...this.queryParams
      }, `pmsOrderOut_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
